unit UTGeom;

interface

uses
  math, UMetBase,graphics ;

  procedure TG_Zoom_2X_Flojo    (matriz  : matImg; var matrizSal: matImg);
  procedure TG_Zoom_2X_Promedio (matriz  : matImg; var matrizSal: matImg);
  procedure TG_Zoom_0p5X_Flojo  (matriz  : matImg; var matrizSal: matImg);
  procedure TG_Rota_90neg       (matriz  : matImg; var matrizSal: matImg);
  procedure TG_Rota_90pos       (matriz  : matImg; var matrizSal: matImg);
  procedure TG_Rota_180         (matriz  : matImg; var matrizSal: matImg);
  procedure TG_ZoomLibre_VMC    (matriz  : matImg; var matrizSal: matImg;
                                 nTx, nTy : integer);
  procedure TG_ZoomLibre_ILI    (matriz   : matImg; var matrizSal: matImg;
                                 nTx, nTy : integer);
  procedure TG_RotaLibre_VMC    (matriz   : matImg; var matrizSal: matImg;
                                 angulo : single);



implementation

// Zoom 2X del Flojo o de Paint
procedure TG_Zoom_2X_Flojo (matriz  : matImg; var matrizSal: matImg);
var
  kx,ky,cc,
  kx2,ky2,
  ky2m1,
  nnc,nnr  : integer;

  tono     : single;
begin
  nnc := 2*matriz.nc;
  nnr := 2*matriz.nr;

  _x1 := 0; _x2 := nnc;
  _y1 := 0; _y2 := nnr;

  DefMatriz(matrizSal,nnc,nnr);

  for cc := 0 to 2 do
    for ky := 0 to matriz.nr-1 do begin
      ky2   := ky SHL 1;
      ky2m1 := succ(ky2);
      for kx := 0 to matriz.nc-1 do begin
        tono := matriz.dat[kx][ky][cc];
        kx2 := kx SHL 1;

        matrizSal.dat[kx2  ][ky2  ][cc] := tono ;
        matrizSal.dat[kx2+1][ky2  ][cc] := tono ;
        matrizSal.dat[kx2  ][ky2m1][cc] := tono ;
        matrizSal.dat[kx2+1][ky2m1][cc] := tono ;
      end;
    end;
end;

// Zoom 2X por promedios
procedure TG_Zoom_2X_Promedio (matriz  : matImg; var matrizSal: matImg);
var
  kx,ky,cc,
  kx2,ky2,
  ky2m1,
  kx2m1,
  px,py,
  nnc,nnr  : integer;
  p,q,r,s  : single;

begin
  nnc := 2*matriz.nc;
  nnr := 2*matriz.nr;

  _x1 := 0; _x2 := nnc;
  _y1 := 0; _y2 := nnr;

  DefMatriz(matrizSal,nnc,nnr);

  // procesa bloque principal
  for cc := 0 to 2 do
    for ky := 0 to matriz.nr-2 do begin
      ky2   := ky SHL 1;
      ky2m1 := succ(ky2);
      py    := succ(ky);

      for kx := 0 to matriz.nc-2 do begin
        px := succ(kx);

        p := matriz.dat[kx][ky][cc];
        q := matriz.dat[px][ky][cc];
        r := matriz.dat[kx][py][cc];
        s := matriz.dat[px][py][cc];

        kx2 := kx SHL 1;
        matrizSal.dat[kx2  ][ky2  ][cc] :=  p ;
        matrizSal.dat[kx2+1][ky2  ][cc] := (p+q)/2 ;
        matrizSal.dat[kx2  ][ky2m1][cc] := (p+r)/2 ;
        matrizSal.dat[kx2+1][ky2m1][cc] := (p+s)/2 ;
      end;
    end;

  // ltima columna
  kx    := matriz.nc-1;
  kx2   := kx SHL 1;
  kx2m1 := succ(kx2);
  for cc := 0 to 2 do
    for ky := 0 to matriz.nr-2 do begin
      ky2   := ky SHL 1;
      ky2m1 := succ(ky2);
      py    := succ(ky);

      p := matriz.dat[kx][ky][cc];
      q := matriz.dat[kx][py][cc];
      r := (p+q)/2;

      matrizSal.dat[kx2  ][ky2  ][cc] :=  p ;
      matrizSal.dat[kx2m1][ky2  ][cc] :=  p ;
      matrizSal.dat[kx2  ][ky2m1][cc] :=  r ;
      matrizSal.dat[kx2m1][ky2m1][cc] :=  r ;
    end;

  // ltimo rengln
  ky    := matriz.nr-1;
  ky2   := ky SHL 1;
  ky2m1 := succ(ky2);
  for cc := 0 to 2 do
    for kx := 0 to matriz.nc-2 do begin
      kx2    := kx SHL 1;
      kx2m1  := succ(kx2);
      px     := succ(kx);

      p := matriz.dat[kx][ky][cc];
      q := matriz.dat[px][ky][cc];
      r := (p+q)/2;

      matrizSal.dat[kx2  ][ky2  ][cc] :=  p ;
      matrizSal.dat[kx2m1][ky2  ][cc] :=  r ;
      matrizSal.dat[kx2  ][ky2m1][cc] :=  p ;
      matrizSal.dat[kx2m1][ky2m1][cc] :=  r ;
    end;

  // ltimo pixel :: esquina derecha inferior
  kx    := matriz.nc-1;
  ky    := matriz.nr-1;
  kx2   := kx SHL 1;
  ky2   := ky SHL 1;
  kx2m1 := succ(kx2);
  ky2m1 := succ(ky2);

  for cc := 0 to 2 do begin
    p := matriz.dat[kx][ky][cc];

    matrizSal.dat[kx2  ][ky2  ][cc] :=  p ;
    matrizSal.dat[kx2m1][ky2  ][cc] :=  p ;
    matrizSal.dat[kx2  ][ky2m1][cc] :=  p ;
    matrizSal.dat[kx2m1][ky2m1][cc] :=  p ;
  end;

end;

// Zoom 2X del Flojo o de Paint
procedure TG_Zoom_0p5X_Flojo (matriz  : matImg; var matrizSal: matImg);
var
  kx,ky,cc,
  kx2,ky2,
  nnc,nnr  : integer;

  tono     : single;
begin
  nnc := matriz.nc div 2;
  nnr := matriz.nr div 2;

  _x1 := 0;_x2 := nnc;
  _y1 := 0;_y2 := nnr;

  DefMatriz(matrizSal,nnc,nnr);

  for cc := 0 to 2 do
    for ky := 0 to nnr-1 do begin
      ky2   := ky SHL 1;
      for kx := 0 to nnc-1 do begin
        kx2 := kx SHL 1;
        tono := matriz.dat[kx2][ky2][cc];

        matrizSal.dat[kx][ky][cc] := tono ;
      end;
    end;
end;

// Rota 90 simple
procedure TG_Rota_90pos (matriz  : matImg; var matrizSal: matImg);
var
  kx,ky,cc,kyinv,
  nnc,nnr  : integer;

begin
  nnr := matriz.nc;
  nnc := matriz.nr;

  _x1 := 0; _x2 := nnc;
  _y1 := 0; _y2 := nnr;

  DefMatriz(matrizSal,nnc,nnr);

  for cc := 0 to 2 do
    for kx := 0 to matriz.nc-1 do begin
      for ky := 0 to matriz.nr-1 do begin
        kyinv := matriz.nr-1-ky;

        MatrizSal.dat[kyinv][kx][cc] := matriz.dat[kx][ky][cc];
      end;
    end;
end;

// Rota -90 simple
procedure TG_Rota_90neg (matriz  : matImg; var matrizSal: matImg);
var
  kx,ky,cc,kxinv,
  nnc,nnr  : integer;

begin
  nnr := matriz.nc;
  nnc := matriz.nr;

  _x1 := 0; _x2 := nnc;
  _y1 := 0; _y2 := nnr;

  DefMatriz(matrizSal,nnc,nnr);

  for cc := 0 to 2 do
    for ky := 0 to matriz.nr-1 do begin
      for kx := 0 to matriz.nc-1 do begin
        kxinv := matriz.nc-1-kx;

        MatrizSal.dat[ky][kxinv][cc] := matriz.dat[kx][ky][cc];
      end;
    end;
end;

// Rota 180 simple
procedure TG_Rota_180 (matriz  : matImg; var matrizSal: matImg);
var
  kx,ky,cc,
  kxinv, kyinv,
  nnc,nnr       : integer;

begin
  nnc := matriz.nc;
  nnr := matriz.nr;

  _x1 := 0; _x2 := nnc;
  _y1 := 0; _y2 := nnr;

  DefMatriz(matrizSal,nnc,nnr);

  for cc := 0 to 2 do
    for ky := 0 to matriz.nr-1 do begin
      kyinv := matriz.nr-1-ky;
      for kx := 0 to matriz.nc-1 do begin
        kxinv := matriz.nc-1-kx;

        MatrizSal.dat[kxinv][kyinv][cc] := matriz.dat[kx][ky][cc];
      end;
    end;
end;

// Zoom Libre Vecino Mas Cercano
procedure TG_ZoomLibre_VMC (matriz   : matImg; var matrizSal: matImg;
                            nTx, nTy : integer);
var
  kx,ky,cc,
  kx2,ky2  : integer;

  fx,fy,
  tono     : single;
begin
  // factores de escala
  fx  := (matriz.nc-1)/(nTx-1);
  fy  := (matriz.nr-1)/(nTy-1);

  _x1 := 0; _x2 := nTx;
  _y1 := 0; _y2 := nTy;

  DefMatriz(matrizSal,nTx,nTy);

  for cc := 0 to 2 do
    for ky := 0 to nTy-1 do begin
      ky2   := floor(fy*ky);
      for kx := 0 to nTx-1 do begin
        kx2 := floor(fx*kx);
        tono := matriz.dat[kx2][ky2][cc];

        matrizSal.dat[kx][ky][cc] := tono ;
      end;
    end;
end;

procedure TG_ZoomLibre_ILI (matriz   : matImg; var matrizSal: matImg;
                            nTx, nTy : integer);
var
  kx,ky,cc,
  kxp,kyp,
  kxpm1,
  kypm1     : integer;

  xr,yr,
  ex,ey,
  dx,dy,
  fx,fy,

  t1,t2,
  t3,t4,
  f1,f2,
  f3,f4     : single;

begin
  // factores de escala
  fx  := (matriz.nc-1)/(nTx-1);
  fy  := (matriz.nr-1)/(nTy-1);

  _x1 := 0; _x2 := nTx;
  _y1 := 0; _y2 := nTy;

  DefMatriz(matrizSal,nTx,nTy);

  for ky := 0 to nTy-2 do begin
    yr  := fy*ky;
    kyp := floor(yr);
    dy  := yr-kyp;
    ey  := 1 - dy;
    kypm1 := succ(kyp);

    for kx := 0 to nTx-2 do begin
      xr  := fx*kx;
      kxp := floor(xr);
      dx  := xr-kxp;
      ex  := 1 - dx;
      kxpm1 := succ(kxp);

      f1 := ex*ey;
      f2 := dx*ey;
      f3 := ex*dy;
      f4 := dx*dy;

      for cc := 0 to 2 do begin
        t1 :=      f1*matriz.dat[kxp  ][kyp  ][cc];
        t2 := t1 + f2*matriz.dat[kxpm1][kyp  ][cc];
        t3 := t2 + f3*matriz.dat[kxp  ][kypm1][cc];
        t4 := t3 + f4*matriz.dat[kxpm1][kypm1][cc];

        matrizSal.dat[kx][ky][cc] := t4 ;
      end;
    end;
  end;
end;

// Rotacion libre Vecino Mas Cercano
procedure TG_RotaLibre_VMC    (matriz   : matImg; var matrizSal: matImg;
                               angulo : single);
var
  nTx,nTy,
  nc,nr,kk,
  kx,ky,cc,
  x1,y1,
  x2,y2,
  kxp,kyp  : integer;

  esqui,
  esqsal   : array [0..3,0..1] of single;

  xmin,xmax,
  ymin,ymax,
  th,
  sth,cth,
  tx,ty,
  tono     : single;

begin
  // mapeo de esquinas
  esqui[0][0] := 0          ; esqui[0][1] := 0;
  esqui[1][0] := matriz.nc-1; esqui[1][1] := 0;
  esqui[2][0] := 0          ; esqui[2][1] := matriz.nr-1;
  esqui[3][0] := matriz.nc-1; esqui[3][1] := matriz.nr-1;

  th := angulo*PI/180;
  sth := sin(th);
  cth := cos(th);
  for kk := 0 to 3 do begin
    esqsal[kk][0] :=  cth*esqui[kk][0] +  sth*esqui[kk][1];
    esqsal[kk][1] := -sth*esqui[kk][0] +  cth*esqui[kk][1];
  end;

  // cotas mayor y menor X' e Y'
  xmin := esqsal[0][0];
  xmax := xmin;
  ymin := esqsal[0][1];
  ymax := ymin;
  for kk := 1 to 3 do begin
    xmin := MIN(xmin,esqsal[kk][0]);
    xmax := MAX(xmax,esqsal[kk][0]);
    ymin := MIN(ymin,esqsal[kk][1]);
    ymax := MAX(ymax,esqsal[kk][1]);
  end;

  x1 := ceil(xmin);  y1 := ceil(ymin);
  x2 := ceil(xmax);  y2 := ceil(ymax);

  // Determinacion del lienzo
  nTx := ceil(xmax - xmin + 1);
  nTy := ceil(ymax - ymin + 1);

  // actualizar las variables de lienzo completo
  _x1 := 0; _x2 := nTx;
  _y1 := 0; _y2 := nTy;
  DefMatriz(matrizSal,nTx,nTy);

  // rotacion misma
  nc := matriz.nc;
  nr := matriz.nr;

  for cc := 0 to 2 do
    for ky := y1 to y2 do begin
      tx := -sth*ky;
      ty :=  cth*ky;
      for kx := x1 to x2 do begin
        kxp := ceil(cth*kx + tx);
        kyp := ceil(sth*kx + ty);

        if  (kxp>=0 ) and (kyp>=0 ) and (kxp<nc ) and (kyp<nr ) then begin
          tono := matriz.dat[kxp][kyp][cc];
          matrizSal.dat[kx-x1][ky-y1][cc] := tono ;
        end
        else matrizSal.dat[kx-x1][ky-y1][cc] := 127 ;
      end;
    end;
end;


end.
